## libcbor 0.5.0%2Bdfsg

=== examples/CMakeLists.txt ===
add_executable(readfile readfile.c)
target_link_libraries(readfile cbor)

add_executable(create_items create_items.c)
target_link_libraries(create_items cbor)

add_executable(streaming_parser streaming_parser.c)
target_link_libraries(streaming_parser cbor)

add_executable(sort sort.c)
target_link_libraries(sort cbor)

add_executable(hello hello.c)
target_link_libraries(hello cbor)

find_package(cJSON)

if(cJSON_FOUND)
    add_executable(cjson2cbor cjson2cbor.c)
    target_link_libraries(cjson2cbor cbor cjson)
endif()

file(COPY data DESTINATION .)

=== debian/control ===
Source: libcbor
Priority: optional
Maintainer: Vincent Bernat <bernat@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               libcmocka-dev,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-breathe
Standards-Version: 4.1.2
Section: libs
Homepage: https://github.com/PJK/libcbor
Vcs-Git: https://salsa.debian.org/debian/libcbor.git
Vcs-Browser: https://salsa.debian.org/debian/libcbor/

Package: libcbor0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for parsing and generating CBOR (RFC 7049)
 CBOR is a general-purpose schema-less binary data format, defined in
 RFC 7049. This package provides a C library for parsing and generating
 CBOR. The main features are:
 .
  - Complete RFC conformance
  - Robust C99 implementation
  - Layered architecture offers both control and convenience
  - Flexible memory management
  - No shared global state - threading friendly
  - Proper handling of UTF-8
  - Full support for streams & incremental processing
  - Extensive documentation and test suite
  - No runtime dependencies, small footprint
 .
 This package contains the runtime library.

Package: libcbor-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcbor0 (= ${binary:Version}), ${misc:Depends}
Description: library for parsing and generating CBOR (RFC 7049) (development headers)
 CBOR is a general-purpose schema-less binary data format, defined in
 RFC 7049. This package provides a C library for parsing and generating
 CBOR.
 .
 This package contains the development headers.

Package: libcbor-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}, libjs-mathjax
Description: library for parsing and generating CBOR (RFC 7049) (documentation)
 CBOR is a general-purpose schema-less binary data format, defined in
 RFC 7049. This package provides a C library for parsing and generating
 CBOR.
 .
 This package contains the documentation

## libcbor 0.5.0+dfsg

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/libcbor.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/libcbor.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/libcbor"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/libcbor"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

livehtml: html
	sphinx-autobuild -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

=== src/CMakeLists.txt ===
set(SOURCES cbor.c cbor/streaming.c cbor/internal/encoders.c cbor/internal/builder_callbacks.c cbor/internal/loaders.c cbor/internal/memory_utils.c cbor/internal/stack.c cbor/internal/unicode.c cbor/encoding.c cbor/serialization.c cbor/arrays.c cbor/common.c cbor/floats_ctrls.c cbor/bytestrings.c cbor/callbacks.c cbor/strings.c cbor/maps.c cbor/tags.c cbor/ints.c)

include(GNUInstallDirs)
set(CMAKE_SKIP_BUILD_RPATH FALSE)

if (CBOR_CUSTOM_ALLOC)
    LIST(APPEND SOURCES allocators.c)
endif(CBOR_CUSTOM_ALLOC)

if (NOT DEFINED CMAKE_MACOSX_RPATH)
	set(CMAKE_MACOSX_RPATH 0)
endif()

add_library(cbor ${SOURCES})
add_library(cbor_shared SHARED ${SOURCES})

set_target_properties(cbor_shared PROPERTIES OUTPUT_NAME cbor VERSION "0.0.0" SOVERSION 0)

configure_file(libcbor.pc.in libcbor.pc @ONLY)

#http://www.cmake.org/Wiki/CMake:Install_Commands

install(TARGETS cbor  cbor_shared
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION bin)

install(DIRECTORY cbor DESTINATION include
                FILES_MATCHING PATTERN "*.h")

install(FILES cbor.h DESTINATION include)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libcbor.pc"
	DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
libcbor (0.5.0+dfsg-2) unstable; urgency=medium

  * d/control: migrate to salsa.debian.org.
  * d/install: install pkg-config file.

 -- Vincent Bernat <bernat@debian.org>  Thu, 17 May 2018 17:08:03 +0200

libcbor (0.5.0+dfsg-1) unstable; urgency=medium

  * Initial release. Closes: #787015.

 -- Vincent Bernat <bernat@debian.org>  Mon, 18 Dec 2017 07:26:05 +0100

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with sphinxdoc

override_dh_auto_build:
	dh_auto_build
	mkdir -p doc/build/doxygen
	doxygen
	make -C doc html
	# Nothing is using MathJax
	find doc/build/html -type f -print0 | xargs -0 sed -i '/ajax\/libs\/mathjax/d'

=== debian/watch ===
version=4
opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libcbor-$1.tar.gz/,\
dversionmangle=s/\+dfsg(\.?\d+)?$//,\
repacksuffix=+dfsg \
 https://github.com/PJK/libcbor/tags .*/v(\d[\d\.]*)\.tar\.gz

## libcbor 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libcbor)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")
include(CTest)

SET(CBOR_VERSION_MAJOR "0")
SET(CBOR_VERSION_MINOR "6")
SET(CBOR_VERSION_PATCH "0")
SET(CBOR_VERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR}.${CBOR_VERSION_PATCH})

set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)
include(CheckIncludeFiles)

include(TestBigEndian)
test_big_endian(BIG_ENDIAN)
if(BIG_ENDIAN)
    add_definitions(-DIS_BIG_ENDIAN)
endif()

option(CBOR_CUSTOM_ALLOC "Custom, dynamically defined allocator support" OFF)
option(CBOR_PRETTY_PRINTER "Include a pretty-printing routine" ON)
set(CBOR_BUFFER_GROWTH "2" CACHE STRING "Factor for buffer growth & shrinking")

option(WITH_TESTS "[TEST] Build unit tests (requires CMocka" OFF)
if(WITH_TESTS)
    add_definitions(-DWITH_TESTS)
endif(WITH_TESTS)

option(WITH_EXAMPLES "Build examples" ON)

option(HUGE_FUZZ "[TEST] Fuzz through 8GB of data in the test. Do not use with memory instrumentation!" OFF)
if(HUGE_FUZZ)
    add_definitions(-DHUGE_FUZZ)
endif(HUGE_FUZZ)

option(SANE_MALLOC "[TEST] Assume that malloc will not allocate multi-GB blocks. Tests only, platform specific" OFF)
if(SANE_MALLOC)
    add_definitions(-DSANE_MALLOC)
endif(SANE_MALLOC)

option(PRINT_FUZZ "[TEST] Print the fuzzer input" OFF)
if(PRINT_FUZZ)
    add_definitions(-DPRINT_FUZZ)
endif(PRINT_FUZZ)

option(SANITIZE "Enable ASan & a few compatible sanitizers in Debug mode" ON)

set(CPACK_GENERATOR "DEB" "TGZ" "RPM")
set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Pavel Kalvoda")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6")
set(CPACK_PACKAGE_VERSION_MAJOR ${CBOR_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CBOR_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CBOR_VERSION_PATCH})

include(CPack)

if(MINGW)
    # https://github.com/PJK/libcbor/issues/13
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
elseif(NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
endif()

if(MSVC)
    # This just doesn't work right -- https://msdn.microsoft.com/en-us/library/5ft82fed.aspx
    set(CBOR_RESTRICT_SPECIFIER "")
else()
    set(CBOR_RESTRICT_SPECIFIER "restrict")

    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -Wall -pedantic -g -ggdb -DDEBUG=true")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -flto -Wall -pedantic -DNDEBUG")

    if(SANITIZE)
        set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} \
            -fsanitize=undefined -fsanitize=address \
            -fsanitize=bounds -fsanitize=alignment")
    endif()
endif()

set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-g")
set(CMAKE_EXE_LINKER_FLAGS_RELEASE "-flto")


include(CheckTypeSize)
check_type_size("size_t" SIZEOF_SIZE_T)
if(SIZEOF_SIZE_T LESS 8)
    message(WARNING "Your size_t is less than 8 bytes. Long items with 64b length specifiers might not work as expected. Make sure to run the tests!")
else()
    add_definitions(-DEIGHT_BYTE_SIZE_T)
endif()

enable_testing()

set(CTEST_MEMORYCHECK_COMMAND "/usr/bin/valgrind")
set(MEMORYCHECK_COMMAND_OPTIONS "--tool=memcheck --track-origins=yes --leak-check=full --error-exitcode=1")

add_custom_target(coverage
                  COMMAND ctest
                  COMMAND lcov --capture --directory . --output-file coverage.info
                  COMMAND genhtml coverage.info --highlight --legend --output-directory coverage_html
                  COMMAND echo "Coverage report ready: file://${CMAKE_CURRENT_BINARY_DIR}/coverage_html/index.html")
include_directories(src)


option(COVERAGE "Enable code coverage instrumentation" OFF)
if (COVERAGE)
    message("Configuring code coverage instrumentation")
    if(NOT CMAKE_C_COMPILER MATCHES "gcc")
        message(WARNING "Gcov instrumentation only works with GCC")
    endif()
    # https://gcc.gnu.org/onlinedocs/gcc/Debugging-Options.html
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage --coverage")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -g -fprofile-arcs -ftest-coverage --coverage")
endif (COVERAGE)


# We want to generate configuration.h from the template and make it so that it is accessible using the same
# path during both library build and installed header use, without littering the source dir.
# Using cbor/configuration.h in the build dir works b/c headers will be installed to <prefix>/cbor
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/cbor/configuration.h.in ${PROJECT_BINARY_DIR}/cbor/configuration.h)
install(FILES ${PROJECT_BINARY_DIR}/cbor/configuration.h DESTINATION include/cbor)
# Make the header visible at compile time
include_directories(${PROJECT_BINARY_DIR})

subdirs(src)

if (WITH_TESTS)
    subdirs(test)
endif (WITH_TESTS)

if (WITH_EXAMPLES)
     subdirs(examples)
endif (WITH_EXAMPLES)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,16 +11,16 @@
 	set(CMAKE_MACOSX_RPATH 0)
 endif()
 
-add_library(cbor ${SOURCES})
+add_library(cbor STATIC ${SOURCES})
 add_library(cbor_shared SHARED ${SOURCES})
 
-set_target_properties(cbor_shared PROPERTIES OUTPUT_NAME cbor VERSION "0.0.0" SOVERSION 0)
+set_target_properties(cbor_shared PROPERTIES OUTPUT_NAME cbor VERSION ${CBOR_VERSION} SOVERSION ${CBOR_VERSION})
 
 configure_file(libcbor.pc.in libcbor.pc @ONLY)
 
 #http://www.cmake.org/Wiki/CMake:Install_Commands
 
-install(TARGETS cbor  cbor_shared
+install(TARGETS cbor_shared
 	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
 	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
 	RUNTIME DESTINATION bin)

=== test/CMakeLists.txt ===
file(GLOB TESTS "*_test.c")

find_package(CMocka REQUIRED)

message(STATUS "CMocka vars: ${CMOCKA_LIBRARIES} ${CMOCKA_INCLUDE_DIR}")

foreach (TEST ${TESTS})
    string(REGEX REPLACE ".*/([^/]+).c" "\\1" NAME ${TEST})
    message("Adding test ${NAME}")
    add_executable(${NAME} "${NAME}.c" assertions.c stream_expectations.c)
    target_link_libraries(${NAME} ${CMOCKA_LIBRARIES})
    target_link_libraries(${NAME} cbor)
    target_include_directories(${NAME} PUBLIC ${CMOCKA_INCLUDE_DIR})
    # See https://stackoverflow.com/a/10824578/499521
    ADD_TEST(ctest_build_test_${NAME}
            "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target ${NAME})
    ADD_TEST(ctest_run_${NAME} ${NAME})
    SET_TESTS_PROPERTIES(ctest_run_${NAME}
            PROPERTIES DEPENDS ctest_build_test_${NAME})
    add_dependencies(coverage ${NAME})
endforeach (TEST)

add_executable(cpp_linkage_test cpp_linkage_test.cpp)
target_link_libraries(cpp_linkage_test cbor)

=== debian/changelog ===
libcbor (0.6.0-0ubuntu1) focal; urgency=medium

  * New upstream version 0.6.0 (LP: #1868609):
    - no need for dfsg since docs/doxygen is no longer shipped
  * d/rules: override auto_configure to enable tests and set the build
    type to "Release" as shown in the upstream build instructions.
  * d/p/skip-custom-allocator-test.patch: skip custom allocator test if
    CBOR_CUSTOM_ALLOC is undefined
  * d/rules: add hardening=+all
  * Fix soname versioning:
    - d/p/clarify-soname-versioning.patch: adjust soname versioning to
      match expectations $MAJOR.$MINOR.$PATCH
    - d/control: rename binary package to match soname 0.6
    - d/control: fix -dev dependency towards its binary lib
    - d/libcbor0.6.install, d/libcbor0.6.symbols: rename to match new soname
    - d/libcbor0.6.symbols: symbols update, add B-D-P field
  * d/libcbor-doc.examples: rename so examples are installed
  * d/control: bump debhelper to 12
  * d/copyright lintian fixes:
    - d/copyright: change url to https
    - d/copyright: remove Files-Excluded since that directory is not
      shipped in the 0.6.0 upstream tarball.
    - d/copyright: removed entry about docs/stylesheets/github-light.css
      as this isn't shipped anymore in the upstream tarball.
  * d/control: set R3 to no
  * d/copyright: add new paragraph for new files in 0.6.0
  * d/control: bump standards-version to 4.5.0 (no changes required)
  * d/watch: remove dfsg mangling

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 25 Mar 2020 19:22:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: libcbor
 Priority: optional
-Maintainer: Vincent Bernat <bernat@debian.org>
-Build-Depends: debhelper (>= 9),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Vincent Bernat <bernat@debian.org>
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libcmocka-dev,
                python3-sphinx,
                python3-sphinx-rtd-theme,
                python3-breathe
-Standards-Version: 4.1.2
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/PJK/libcbor
 Vcs-Git: https://salsa.debian.org/debian/libcbor.git
 Vcs-Browser: https://salsa.debian.org/debian/libcbor/
+Rules-Requires-Root: no
 
-Package: libcbor0
+Package: libcbor0.6
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -38,7 +40,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcbor0 (= ${binary:Version}), ${misc:Depends}
+Depends: libcbor0.6 (= ${binary:Version}), ${misc:Depends}
 Description: library for parsing and generating CBOR (RFC 7049) (development headers)
  CBOR is a general-purpose schema-less binary data format, defined in
  RFC 7049. This package provides a C library for parsing and generating

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,13 @@
 #!/usr/bin/make -f
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ --with sphinxdoc
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DWITH_TESTS=ON
 
 override_dh_auto_build:
 	dh_auto_build

=== debian/watch ===
version=4
opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libcbor-$1.tar.gz/
https://github.com/PJK/libcbor/tags .*/v(\d[\d\.]*)\.tar\.gz

## libcbor 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include(CTest)
 
 SET(CBOR_VERSION_MAJOR "0")
-SET(CBOR_VERSION_MINOR "6")
+SET(CBOR_VERSION_MINOR "8")
 SET(CBOR_VERSION_PATCH "0")
 SET(CBOR_VERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR}.${CBOR_VERSION_PATCH})
 
@@ -20,8 +20,9 @@
 option(CBOR_CUSTOM_ALLOC "Custom, dynamically defined allocator support" OFF)
 option(CBOR_PRETTY_PRINTER "Include a pretty-printing routine" ON)
 set(CBOR_BUFFER_GROWTH "2" CACHE STRING "Factor for buffer growth & shrinking")
+set(CBOR_MAX_STACK_SIZE "2048" CACHE STRING "maximum size for decoding context stack")
 
-option(WITH_TESTS "[TEST] Build unit tests (requires CMocka" OFF)
+option(WITH_TESTS "[TEST] Build unit tests (requires CMocka)" OFF)
 if(WITH_TESTS)
     add_definitions(-DWITH_TESTS)
 endif(WITH_TESTS)
@@ -59,7 +60,7 @@
     # https://github.com/PJK/libcbor/issues/13
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
 elseif(NOT MSVC)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -pedantic")
 endif()
 
 if(MSVC)
@@ -68,8 +69,8 @@
 else()
     set(CBOR_RESTRICT_SPECIFIER "restrict")
 
-    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -Wall -pedantic -g -ggdb -DDEBUG=true")
-    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -flto -Wall -pedantic -DNDEBUG")
+    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -Wall -g -ggdb -DDEBUG=true")
+    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -Wall -DNDEBUG")
 
     if(SANITIZE)
         set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} \
@@ -79,7 +80,6 @@
 endif()
 
 set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-g")
-set(CMAKE_EXE_LINKER_FLAGS_RELEASE "-flto")
 
 
 include(CheckTypeSize)
@@ -123,12 +123,37 @@
 # Make the header visible at compile time
 include_directories(${PROJECT_BINARY_DIR})
 
+# CMake >= 3.9.0 enables LTO for GCC and Clang with INTERPROCEDURAL_OPTIMIZATION
+# Policy CMP0069 enables this behavior when we set the minimum CMake version < 3.9.0
+# Checking for LTO support before setting INTERPROCEDURAL_OPTIMIZATION is mandatory with CMP0069 set to NEW.
+set(use_lto FALSE)
+if(${CMAKE_VERSION} VERSION_GREATER "3.9.0" OR ${CMAKE_VERSION} VERSION_EQUAL "3.9.0")
+    cmake_policy(SET CMP0069 NEW)
+    # Require LTO support to build libcbor with newer CMake versions
+    include(CheckIPOSupported)
+    check_ipo_supported(RESULT use_lto)
+endif(${CMAKE_VERSION} VERSION_GREATER "3.9.0" OR ${CMAKE_VERSION} VERSION_EQUAL "3.9.0")
+if(use_lto)
+    message(STATUS "LTO is enabled")
+else()
+    message(STATUS "LTO is not enabled")
+endif(use_lto)
+
 subdirs(src)
+if(use_lto)
+    set_property(DIRECTORY src PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
+endif(use_lto)
 
 if (WITH_TESTS)
     subdirs(test)
+    if(use_lto)
+        set_property(DIRECTORY test PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
+    endif(use_lto)
 endif (WITH_TESTS)
 
 if (WITH_EXAMPLES)
-     subdirs(examples)
+    subdirs(examples)
+    if(use_lto)
+        set_property(DIRECTORY examples PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
+    endif(use_lto)
 endif (WITH_EXAMPLES)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -13,11 +13,12 @@
 add_executable(hello hello.c)
 target_link_libraries(hello cbor)
 
-find_package(cJSON)
+find_package(CJSON)
 
-if(cJSON_FOUND)
+if(CJSON_FOUND)
     add_executable(cjson2cbor cjson2cbor.c)
-    target_link_libraries(cjson2cbor cbor cjson)
+    target_include_directories(cjson2cbor PUBLIC ${CJSON_INCLUDE_DIRS})
+    target_link_libraries(cjson2cbor cbor ${CJSON_LIBRARY})
 endif()
 
 file(COPY data DESTINATION .)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,24 +11,35 @@
 	set(CMAKE_MACOSX_RPATH 0)
 endif()
 
-add_library(cbor STATIC ${SOURCES})
-add_library(cbor_shared SHARED ${SOURCES})
+add_library(cbor ${SOURCES})
+target_include_directories(cbor PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
 
-set_target_properties(cbor_shared PROPERTIES OUTPUT_NAME cbor VERSION ${CBOR_VERSION} SOVERSION ${CBOR_VERSION})
+include(GenerateExportHeader)
+generate_export_header(cbor EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/cbor/cbor_export.h)
+target_include_directories(cbor PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cbor/cbor_export.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cbor)
+
+if (NOT ${CBOR_VERSION_MAJOR} EQUAL 0)
+	MESSAGE(FATAL_ERROR "Change the shared library version scheme to reflect https://github.com/PJK/libcbor/issues/52.")
+endif()
+
+set_target_properties(cbor PROPERTIES
+		VERSION ${CBOR_VERSION}
+		MACHO_COMPATIBILITY_VERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR}.0
+		SOVERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR})
 
 configure_file(libcbor.pc.in libcbor.pc @ONLY)
 
-#http://www.cmake.org/Wiki/CMake:Install_Commands
-
-install(TARGETS cbor_shared
+# http://www.cmake.org/Wiki/CMake:Install_Commands
+install(TARGETS cbor
 	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
 	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-	RUNTIME DESTINATION bin)
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
-install(DIRECTORY cbor DESTINATION include
+install(DIRECTORY cbor DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
                 FILES_MATCHING PATTERN "*.h")
 
-install(FILES cbor.h DESTINATION include)
+install(FILES cbor.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libcbor.pc"
 	DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== debian/changelog ===
libcbor (0.8.0-2ubuntu1) jammy; urgency=medium

  * Merge from Debian; remaining changes:
    - d/control: set R3 to no
    - d/rules: add hardening=+all
    - d/rules: override auto_configure to enable tests and set the build
      type to "Release" as shown in the upstream build instructions.
    - d/libcbor0.8.symbols: symbols update, add B-D-P field
    - d/copyright: add new paragraph for new files in 0.6.0
  * Dropped changes; applied upstream:
    - d/p/skip-custom-allocator-test.patch
    - d/p/clarify-soname-versioning.patch

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 20 Jan 2022 10:25:28 +0100

libcbor (0.8.0-2) unstable; urgency=medium

  * No changes. Closes: #1000509.

 -- Vincent Bernat <bernat@debian.org>  Wed, 24 Nov 2021 15:29:47 +0100

libcbor (0.8.0-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Vincent Bernat ]
  * New upstream release. Closes: #980300.
  * d/copyright: update years
  * d/control: switch to debhelper-compat 13
  * d/rules: build shared lib
  * d/control: bump Standards-Version
  * d/examples: fix installation of example files
  * d/control: rename libcbor0 to libcbor0.8 to match new ABI versioning
  * d/control: add Built-Using for -doc package.

  [ Helmut Grohne ]
  * Reduce Build-Depends: (Closes: #981620)
    + d/rules: Move documentation build to -indep overrides.
    + Enable sphinxdoc dh addon via B-D.
    + Demote all sphinx dependencies to B-D-I. Be explicit about doxygen.
    + d/rules: Skip cmake build in -indep overrides.
    + Demote cmake and cmocka to B-D-A.
    + Annotate cmocka <!nocheck>.

 -- Vincent Bernat <bernat@debian.org>  Wed, 22 Sep 2021 14:35:54 +0200

libcbor (0.6.0-0ubuntu4) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:14:27 +0200

libcbor (0.6.0-0ubuntu3) groovy; urgency=medium

  * Drop cf-protection LDFLAGS, and thus this is now a no change rebuild
    with fixed compiler to enable CET.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 10 Sep 2020 14:16:13 +0100

libcbor (0.6.0-0ubuntu2) groovy; urgency=medium

  * Append cf-protection to LDFLAGS to enable CET protection.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Jun 2020 14:07:49 +0100

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,22 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Vincent Bernat <bernat@debian.org>
-Build-Depends: debhelper-compat (= 12),
-               cmake,
-               libcmocka-dev,
-               python3-sphinx,
-               python3-sphinx-rtd-theme,
-               python3-breathe
+Build-Depends: debhelper-compat (= 13),
+Build-Depends-Arch: cmake,
+                    libcmocka-dev <!nocheck>,
+Build-Depends-Indep: dh-sequence-sphinxdoc,
+                     doxygen,
+                     python3-sphinx,
+                     python3-sphinx-rtd-theme,
+                     python3-breathe
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/PJK/libcbor
 Vcs-Git: https://salsa.debian.org/debian/libcbor.git
-Vcs-Browser: https://salsa.debian.org/debian/libcbor/
+Vcs-Browser: https://salsa.debian.org/debian/libcbor
 Rules-Requires-Root: no
 
-Package: libcbor0.6
+Package: libcbor0.8
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -40,7 +42,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcbor0.6 (= ${binary:Version}), ${misc:Depends}
+Depends: libcbor0.8 (= ${binary:Version}), ${misc:Depends}
 Description: library for parsing and generating CBOR (RFC 7049) (development headers)
  CBOR is a general-purpose schema-less binary data format, defined in
  RFC 7049. This package provides a C library for parsing and generating
@@ -52,6 +54,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}, libjs-mathjax
+Built-Using: ${sphinxdoc:Built-Using}
 Description: library for parsing and generating CBOR (RFC 7049) (documentation)
  CBOR is a general-purpose schema-less binary data format, defined in
  RFC 7049. This package provides a C library for parsing and generating

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DCMAKE_BUILD_TYPE=Release -DWITH_TESTS=ON
override_dh_auto_configure-indep:
override_dh_auto_build-indep:
	mkdir -p doc/build/doxygen
	doxygen
	make -C doc html
	# Nothing is using MathJax
	find doc/build/html -type f -print0 | xargs -0 sed -i '/ajax\/libs\/mathjax/d'
override_dh_auto_install-indep:

## libcbor 0.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 project(libcbor)
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/")
 include(CTest)
 
 SET(CBOR_VERSION_MAJOR "0")
-SET(CBOR_VERSION_MINOR "8")
-SET(CBOR_VERSION_PATCH "0")
+SET(CBOR_VERSION_MINOR "10")
+SET(CBOR_VERSION_PATCH "2")
 SET(CBOR_VERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR}.${CBOR_VERSION_PATCH})
 
 set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)
@@ -18,6 +18,13 @@
 endif()
 
 option(CBOR_CUSTOM_ALLOC "Custom, dynamically defined allocator support" OFF)
+if(CBOR_CUSTOM_ALLOC)
+    message(WARNING 
+        "CBOR_CUSTOM_ALLOC has been deprecated. Custom allocators are now enabled by default."
+        "The flag is a no-op and will be removed in the next version. "
+        "Please remove CBOR_CUSTOM_ALLOC from your build configuation.")
+endif(CBOR_CUSTOM_ALLOC)
+
 option(CBOR_PRETTY_PRINTER "Include a pretty-printing routine" ON)
 set(CBOR_BUFFER_GROWTH "2" CACHE STRING "Factor for buffer growth & shrinking")
 set(CBOR_MAX_STACK_SIZE "2048" CACHE STRING "maximum size for decoding context stack")
@@ -85,7 +92,7 @@
 include(CheckTypeSize)
 check_type_size("size_t" SIZEOF_SIZE_T)
 if(SIZEOF_SIZE_T LESS 8)
-    message(WARNING "Your size_t is less than 8 bytes. Long items with 64b length specifiers might not work as expected. Make sure to run the tests!")
+    message(WARNING "Your size_t is less than 8 bytes. Decoding of huge items that would exceed the memory address space will always fail. Consider implementing a custom streaming decoder if you need to deal with huge items.")
 else()
     add_definitions(-DEIGHT_BYTE_SIZE_T)
 endif()
@@ -99,19 +106,36 @@
                   COMMAND ctest
                   COMMAND lcov --capture --directory . --output-file coverage.info
                   COMMAND genhtml coverage.info --highlight --legend --output-directory coverage_html
-                  COMMAND echo "Coverage report ready: file://${CMAKE_CURRENT_BINARY_DIR}/coverage_html/index.html")
+                  COMMAND echo "Coverage report ready: ${CMAKE_CURRENT_BINARY_DIR}/coverage_html/index.html")
+
+add_custom_target(llvm-coverage
+                    COMMAND make -j 16
+                    COMMAND rm -rf coverage_profiles
+                    COMMAND mkdir coverage_profiles
+                    COMMAND bash -c [[ for TEST in $(ls test/*_test); do LLVM_PROFILE_FILE="coverage_profiles/$(basename -- ${TEST}).profraw" ./${TEST}; done ]]
+                    # VERBATIM makes escaping working, but breaks shell expansions, so we need to explicitly use bash
+                    COMMAND bash -c [[ llvm-profdata merge -sparse $(ls coverage_profiles/*.profraw) -o coverage_profiles/combined.profdata ]]
+                    COMMAND bash -c [[ llvm-cov show -instr-profile=coverage_profiles/combined.profdata test/*_test -format=html > coverage_profiles/report.html ]]
+                    COMMAND bash -c [[ llvm-cov report -instr-profile=coverage_profiles/combined.profdata test/*_test ]]
+                    COMMAND echo "Coverage report ready: ${CMAKE_CURRENT_BINARY_DIR}/coverage_profiles/report.html"
+                    VERBATIM)
+
 include_directories(src)
 
 
-option(COVERAGE "Enable code coverage instrumentation" OFF)
+option(c "Enable code coverage instrumentation" OFF)
 if (COVERAGE)
     message("Configuring code coverage instrumentation")
-    if(NOT CMAKE_C_COMPILER MATCHES "gcc")
-        message(WARNING "Gcov instrumentation only works with GCC")
+    if(CMAKE_C_COMPILER_ID MATCHES "GNU")
+        # https://gcc.gnu.org/onlinedocs/gcc/Debugging-Options.html
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage --coverage")
+        set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -g -fprofile-arcs -ftest-coverage --coverage")
+    elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-instr-generate -fcoverage-mapping")
+        set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -fprofile-instr-generate")
+    else()
+        message(WARNING "Code coverage build not implemented for compiler ${CMAKE_C_COMPILER_ID}")
     endif()
-    # https://gcc.gnu.org/onlinedocs/gcc/Debugging-Options.html
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage --coverage")
-    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -g -fprofile-arcs -ftest-coverage --coverage")
 endif (COVERAGE)
 
 
@@ -139,20 +163,20 @@
     message(STATUS "LTO is not enabled")
 endif(use_lto)
 
-subdirs(src)
+add_subdirectory(src)
 if(use_lto)
     set_property(DIRECTORY src PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
 endif(use_lto)
 
 if (WITH_TESTS)
-    subdirs(test)
+    add_subdirectory(test)
     if(use_lto)
         set_property(DIRECTORY test PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
     endif(use_lto)
 endif (WITH_TESTS)
 
 if (WITH_EXAMPLES)
-    subdirs(examples)
+    add_subdirectory(examples)
     if(use_lto)
         set_property(DIRECTORY examples PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
     endif(use_lto)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,9 @@
-set(SOURCES cbor.c cbor/streaming.c cbor/internal/encoders.c cbor/internal/builder_callbacks.c cbor/internal/loaders.c cbor/internal/memory_utils.c cbor/internal/stack.c cbor/internal/unicode.c cbor/encoding.c cbor/serialization.c cbor/arrays.c cbor/common.c cbor/floats_ctrls.c cbor/bytestrings.c cbor/callbacks.c cbor/strings.c cbor/maps.c cbor/tags.c cbor/ints.c)
+set(SOURCES cbor.c allocators.c cbor/streaming.c cbor/internal/encoders.c cbor/internal/builder_callbacks.c cbor/internal/loaders.c cbor/internal/memory_utils.c cbor/internal/stack.c cbor/internal/unicode.c cbor/encoding.c cbor/serialization.c cbor/arrays.c cbor/common.c cbor/floats_ctrls.c cbor/bytestrings.c cbor/callbacks.c cbor/strings.c cbor/maps.c cbor/tags.c cbor/ints.c)
 
 include(GNUInstallDirs)
+include(JoinPaths)
+include(CheckFunctionExists)
 set(CMAKE_SKIP_BUILD_RPATH FALSE)
-
-if (CBOR_CUSTOM_ALLOC)
-    LIST(APPEND SOURCES allocators.c)
-endif(CBOR_CUSTOM_ALLOC)
 
 if (NOT DEFINED CMAKE_MACOSX_RPATH)
 	set(CMAKE_MACOSX_RPATH 0)
@@ -13,6 +11,12 @@
 
 add_library(cbor ${SOURCES})
 target_include_directories(cbor PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+
+# Explicitly link math.h if necessary
+check_function_exists(ldexp LDEXP_AVAILABLE)
+if (NOT LDEXP_AVAILABLE)
+	target_link_libraries(cbor m)
+endif()
 
 include(GenerateExportHeader)
 generate_export_header(cbor EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/cbor/cbor_export.h)
@@ -28,6 +32,8 @@
 		MACHO_COMPATIBILITY_VERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR}.0
 		SOVERSION ${CBOR_VERSION_MAJOR}.${CBOR_VERSION_MINOR})
 
+join_paths(libdir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
 configure_file(libcbor.pc.in libcbor.pc @ONLY)
 
 # http://www.cmake.org/Wiki/CMake:Install_Commands
@@ -42,4 +48,4 @@
 install(FILES cbor.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libcbor.pc"
-	DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")
+	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== doc/source/requirements.txt ===
alabaster==0.7.12
Babel==2.9.1
breathe==4.33.1
certifi==2022.12.7
charset-normalizer==2.0.12
colorama==0.4.4
docutils==0.17.1
idna==3.3
imagesize==1.3.0
importlib-metadata==4.11.3
Jinja2==3.0.3
livereload==2.6.3
MarkupSafe==2.1.1
packaging==21.3
Pygments==2.11.2
pyparsing==3.0.7
pytz==2021.3
requests==2.27.1
snowballstemmer==2.2.0
Sphinx==4.4.0
sphinx-autobuild==2021.3.14
sphinx-rtd-theme==1.0.0
sphinxcontrib-applehelp==1.0.2
sphinxcontrib-devhelp==1.0.2
sphinxcontrib-htmlhelp==2.0.0
sphinxcontrib-jsmath==1.0.1
sphinxcontrib-qthelp==1.0.3
sphinxcontrib-serializinghtml==1.1.5
tornado==6.1
urllib3==1.26.9
zipp==3.7.0

=== debian/changelog ===
libcbor (0.10.2-2) unstable; urgency=medium

  * Ack NMU.
  * d/patches: temporarily add a patch to fix FTBFS due to NaN encoding on
    some architectures until this is fixed upstream. See #1069959. Patch
    from Helge Deller.

 -- Vincent Bernat <bernat@debian.org>  Sun, 15 Sep 2024 10:35:51 +0200

libcbor (0.10.2-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/p/Fix-non-standard-testing.patch:
    Enable testing by default and toggle testing based on
    BUILD_TESTING CMake variable. (Closes: #1064018)
  * d/control: Build-Depend-Arch on debhelper (>= 13.12~) when <nocheck>
    build profile is active because the BUILD_TESTING CMake variable is
    automatically set to OFF for nocheck builds starting with
    debhelper 13.12.

 -- Plasma (David Paul) <davidpaul@librem.one>  Thu, 15 Feb 2024 20:46:41 -0600

libcbor (0.10.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * source only upload to enable migration (Closes: #1052004, #1053491)

 -- Paul Gevers <elbrus@debian.org>  Thu, 05 Oct 2023 08:47:27 +0200

libcbor (0.10.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Vincent Bernat ]
  * New upstream release

 -- Vincent Bernat <bernat@debian.org>  Sat, 02 Sep 2023 17:44:24 +0200

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
override_dh_auto_configure-indep:
override_dh_auto_build-indep:
	mkdir -p doc/build/doxygen
	doxygen
	make -C doc html
	# Nothing is using MathJax
	find doc/build/html -type f -print0 | xargs -0 sed -i '/https:.*mathjax@/d'
override_dh_auto_install-indep:

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libcbor-$1.tar.gz/ \
 https://github.com/PJK/libcbor/tags .*/v(\d[\d\.]*)\.tar\.gz
